Drag and drop in EJ2 JavaScript

6 Feb 20269 minutes to read

Drag and drop is a user interface feature that allows users to select an item or items and move them to a different location or onto another interface element by “dragging” the selected item(s) with a pointing device (such as a mouse) and then “dropping” them at the desired location.

Syncfusion® JavaScript controls support drag and drop functionality through two libraries: Draggable and Droppable.

Draggable

The Syncfusion® Draggable library allows any DOM element to be made draggable by passing it as a parameter to the Draggable constructor. This is useful for creating interactive and user-friendly interfaces, such as allowing a user to reorder items in a list by dragging them. The following code snippet enables draggable functionality for the specific DOM element passed to the Draggable constructor.

var dragElement = document.getElementById('element1');
var draggable = new ej.base.Draggable(dragElement,{clone: false});
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Draggable</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-base/styles/material.css" rel="stylesheet">
    
    
<script src="https://cdn.syncfusion.com/ej2/34.1.29/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        <div id="element1"><p>Draggable Element </p></div>
    </div>



<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Clone draggable element

Syncfusion® provides the option to create a clone of a draggable element while the user is dragging it. This can be achieved by setting the clone property to true. The following example demonstrates how to create a clone of a draggable element.

var dragElement = document.getElementById('element1');
var draggable = new ej.base.Draggable(dragElement,{clone: false});
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Draggable</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-base/styles/material.css" rel="stylesheet">
    
    
<script src="https://cdn.syncfusion.com/ej2/34.1.29/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        <div id="element1"><p>Draggable Element </p></div>
    </div>



<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Drag area

A drag area is a specific area within a user interface that is designated for drag and drop operations. When an object or element is dragged within a drag area, certain actions or events may be triggered. The user can specify the drag area by using the dragArea property. Refer to the below sample.

var draggable = new ej.base.Draggable(document.getElementById('element1'), {
    clone: false
});
var droppable = new ej.base.Droppable(document.getElementById('droppable'), {
    drop: (function (e) {
        e.droppedElement.querySelector('.drag-text').textContent = 'Dropped';
    })
});
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Draggable</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-base/styles/material.css" rel="stylesheet">
    
    
<script src="https://cdn.syncfusion.com/ej2/34.1.29/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        <div id="droppable">
            <p class="drop"><span>Drop Target </span></p></div>
    <div id="element1"><p class="drag-text">Drag </p></div>

    </div>



<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

Droppable

A droppable element refers to an area of a user interface that can receive a draggable element that is being moved by a user. The Syncfusion® Droppable library converts any DOM element into a droppable zone, which accepts draggable elements.

When a draggable element is moved over a droppable element, the drop event can be triggered. Details about the dropped element can be obtained through the event argument. Based on the event argument, the dragged element can be appended to the target element.

Refer to the following code snippet to enable droppable zones.

var draggable = new ej.base.Draggable(document.getElementById('element1'), {
    clone: false
});
var droppable = new ej.base.Droppable(document.getElementById('droppable'), {
    drop: (function (e) {
        e.droppedElement.querySelector('.drag-text').textContent = 'Dropped';
    })
});
<!DOCTYPE html><html lang="en"><head>
    <title>EJ2 Draggable</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-base/styles/material.css" rel="stylesheet">
    
    
<script src="https://cdn.syncfusion.com/ej2/34.1.29/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        <div id="droppable">
            <p class="drop"><span>Drop Target </span></p></div>
    <div id="element1"><p class="drag-text">Drag </p></div>

    </div>



<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

See also

Syncfusion AI Assistant

How can I help you?

Drag and Drop in Vue

3 Feb 202619 minutes to read

Drag and drop is a user interface feature that lets users select an item (or items) and move them to a different location or onto another interface element by dragging with a pointing device (such as a mouse) and dropping at the desired location.

Syncfusion® Vue components support drag and drop feature through two libraries. These are Draggable and Droppable.

Draggable

The Syncfusion® Draggable library allows you to make any DOM element draggable by passing it to the Draggable constructor. This is useful for interactive UI patterns such as reordering a list by dragging items.

Example — enable draggable functionality for a specific DOM element:

<template>
  <div id='container'>
    <div id='element1' ref='element1'>
      <p>Draggable Element </p>
    </div>
  </div>
</template>

<script setup>
import { Draggable } from '@syncfusion/ej2-base';
import { onMounted, ref } from 'vue';

const element1 = ref(null);

onMounted(() => {
  new Draggable(element1.value, { clone: false });
})
</script>

<style>
#element1,
.helper {
  height: 100px;
  width: 150px;
  border: 1px solid #cecece;
  cursor: move;
  user-select: none;
  color: #6a77a7;
  touch-action: none;
}

p {
  padding-top: 23px;
  text-align: center;
}

.helper {
  opacity: 0.6;
}

.select {
  border: 1px solid #cccccc;
  background: #ededed;
}
</style>
<template>
    <div id='container'>
        <div id='element1'>
            <p>Draggable Element </p>
        </div>
    </div>
</template>
<script>
    import { Draggable } from '@syncfusion/ej2-base';
    import Vue from "vue";
    export default {
        mounted: function () {
            var dragElement = document.getElementById('element1');
            var draggable = new Draggable(dragElement, { clone: false });
        }
    }
</script>
<style>
    #element1,
    .helper {
        height: 100px;
        width: 150px;
        border: 1px solid #cecece;
        cursor: move;
        user-select: none;
        color: #6a77a7;
        touch-action: none;
    }

    p {
        padding-top: 23px;
        text-align: center;
    }

    .helper {
        opacity: 0.6;
    }

    .select {
        border: 1px solid #cccccc;
        background: #ededed;
    }
</style>

Clone draggable element

You can create a clone of the draggable element while dragging by setting the clone property to true. Example:

<template>
  <div id='container'>
    <div id='element1' ref='element1'>
      <p>Draggable Element </p>
    </div>
  </div>
</template>

<script setup>
import { Draggable } from '@syncfusion/ej2-base';
import { onMounted, ref } from 'vue';

const element1 = ref(null);

onMounted(() => {
  new Draggable(element1.value, { clone: true });
})
</script>

<style>
#element1,
.helper {
  height: 100px;
  width: 150px;
  border: 1px solid #cecece;
  cursor: move;
  user-select: none;
  color: #6a77a7;
  touch-action: none;
}

p {
  padding-top: 23px;
  text-align: center;
}

.helper {
  opacity: 0.6;
}

.select {
  border: 1px solid #cccccc;
  background: #ededed;
}
</style>
<template>
    <div id='container'>
        <div id='element1'>
            <p>Draggable Element </p>
        </div>
    </div>
</template>
<script>
import { Draggable } from '@syncfusion/ej2-base';
export default {
    mounted: function () {

        var dragElement = document.getElementById('element1');
        var draggable = new Draggable(dragElement, { clone: true });
    }
}
</script>
<style>
#element1,
.helper {
    height: 100px;
    width: 150px;
    border: 1px solid #cecece;
    cursor: move;
    user-select: none;
    color: #6a77a7;
    touch-action: none;
}

p {
    padding-top: 23px;
    text-align: center;
}

.helper {
    opacity: 0.6;
}

.select {
    border: 1px solid #cccccc;
    background: #ededed;
}
</style>

Drag area

A drag area is a specific region designated for drag-and-drop operations. Specify the drag area using the dragArea property. Example:

<template>
  <div id='container'>
    <div id='droppable'>
      <p class='drop'><span>Drag Area </span></p>
    </div>
    <div id='element1' ref='element1'>
      <p class='drag-text'>Drag </p>
    </div>
  </div>
</template>

<script setup>
import { Draggable } from '@syncfusion/ej2-base';
import { onMounted, ref } from 'vue';
const element1 = ref(null)
onMounted(() => {
  new Draggable(element1.value, {
    clone: false, dragArea: "#droppable"
  });
})
</script>

<style>
#element1 {
  height: 100px;
  width: 150px;
  border: 1px solid #cecece;
  cursor: move;
  background: #cdffe3;
  user-select: none;
  touch-action: none;
}

#element1 p {
  padding-top: 23px;
  text-align: center;
}

.drop {
  padding-top: 23px;
  text-align: center;
}

#droppable {
  margin: 5px;
  line-height: 170px;
  font-size: 14px;
  width: 250px;
  border: 1px solid #cecece;
  background: #f6f6f6;
  touch-action: none;
}
</style>
<template>
    <div id='container'>
        <div id='droppable'>
            <p class='drop'><span>Drag Area </span></p>
        </div>
        <div id='element1'>
            <p class='drag-text'>Drag </p>
        </div>

    </div>
</template>
<script>
    import { Draggable, Droppable } from '@syncfusion/ej2-base';
    export default {
        mounted: function () {
            var draggable = new Draggable(document.getElementById('element1'), {
                clone: false, dragArea: "#droppable"
            });
        }
    }
</script>
<style>
    #element1 {
        height: 100px;
        width: 150px;
        border: 1px solid #cecece;
        cursor: move;
        background: #cdffe3;
        user-select: none;
        touch-action: none;
    }

    #element1 p {
        padding-top: 23px;
        text-align: center;

    }

    .drop {
        padding-top: 23px;
        text-align: center;

    }

    #droppable {
        margin: 5px;
        line-height: 170px;
        font-size: 14px;
        width: 250px;
        border: 1px solid #cecece;
        background: #f6f6f6;
        touch-action: none;
    }
</style>

Droppable

A droppable area is an element that can accept draggable elements. The Syncfusion® Droppable library converts any DOM element into a droppable zone.

When a draggable component is moved over a droppable component, the drop event can be triggered. The user can get details about the dropped element through the event argument. Based on the event argument, the user can append the dragged element to the target element.

Refer to the following code snippet to enable droppable zones.

<template>
  <div id='container'>
    <div id='droppable' ref='droppable'>
      <p class='drop'><span>Drop Target </span></p>
    </div>
    <div id='element1' ref='element1'>
      <p class='drag-text' ref="dragText">Drag </p>
    </div>
  </div>
</template>

<script setup>
import { Draggable, Droppable } from '@syncfusion/ej2-base';
import { onMounted, ref } from 'vue';

const element1 = ref(null);
const droppable = ref(null);
const dragText = ref(null);

onMounted(() => {
  new Draggable(element1.value, {
    clone: false
  });
  new Droppable(droppable.value, {
    drop: () => {
      dragText.value.textContent = 'Dropped';
    }
  });
})
</script>

<style>
#element1 {
  height: 100px;
  width: 150px;
  border: 1px solid #cecece;
  cursor: move;
  background: #cdffe3;
  user-select: none;
  touch-action: none;
}

#element1 p {
  padding-top: 23px;
  text-align: center;
}

.drop {
  padding-top: 23px;
  text-align: center;
}

#droppable {
  margin: 5px;
  line-height: 170px;
  font-size: 14px;
  width: 250px;
  border: 1px solid #cecece;
  background: #f6f6f6;
  touch-action: none;
}
</style>
<template>
    <div id='container'>
        <div id='droppable'>
            <p class='drop'><span>Drop Target </span></p>
        </div>
        <div id='element1'>
            <p class='drag-text'>Drag </p>
        </div>

    </div>
</template>
<script>
    import { Draggable, Droppable } from '@syncfusion/ej2-base';
    export default {
        mounted: function () {
            var draggable = new Draggable(document.getElementById('element1'), {
                clone: false
            });
            var droppable = new Droppable(document.getElementById('droppable'), {
                drop: (e) => {
                    e.droppedElement.querySelector('.drag-text').textContent = 'Dropped';
                }
            });
        }
    }
</script>
<style>
    #element1 {
        height: 100px;
        width: 150px;
        border: 1px solid #cecece;
        cursor: move;
        background: #cdffe3;
        user-select: none;
        touch-action: none;
    }

    #element1 p {
        padding-top: 23px;
        text-align: center;

    }

    .drop {
        padding-top: 23px;
        text-align: center;

    }

    #droppable {
        margin: 5px;
        line-height: 170px;
        font-size: 14px;
        width: 250px;
        border: 1px solid #cecece;
        background: #f6f6f6;
        touch-action: none;
    }
</style>

See also

Syncfusion AI Assistant

How can I help you?

Drag and Drop in React

2 Feb 202617 minutes to read

Drag and drop enables users to select one or more items and move them to a different location or onto another interface element by dragging with a mouse, touch, or pen input and releasing at the desired target location.

Syncfusion® React components support drag-and-drop interactions through two core utilities from the @syncfusion/ej2-base package: Draggable and Droppable. These utilities provide a flexible foundation for implementing custom drag-and-drop behaviors, including item reordering, drag handles, constrained movement, and drop target validation.

npm install @syncfusion/ej2-base --save

Import the required utilities in your component:

import { Draggable, Droppable } from '@syncfusion/ej2-base';

Draggable

The Draggable utility transforms any DOM element into a draggable item by instantiating the Draggable class with a target element selector. This utility supports various configuration options to control drag behavior, including movement constraints, cloning, custom drag handles, and event callbacks. The example below demonstrates basic draggable functionality for a specified DOM element.

import * as React from 'react';
import { useEffect } from 'react';
import * as ReactDom from 'react-dom';
import { Draggable } from '@syncfusion/ej2-base';
function App() {
    useEffect(() => {
        let draggable = new Draggable(document.getElementById('element'), { clone: false });
    }, []);
    return (<div id='container'>
          <div id='element'><p>Draggable Element</p></div>
        </div>);
}
export default App;
ReactDom.render(<App />, document.getElementById('sample'));
import * as  React from 'react';
import { useEffect } from 'react';
import * as ReactDom from 'react-dom';
import { Draggable } from '@syncfusion/ej2-base';

function App() {

    useEffect(() => {
        let draggable: Draggable = new Draggable(document.getElementById('element'),{ clone: false });
    },[])

    return (
        <div id='container'>
          <div id='element'><p>Draggable Element</p></div>
        </div>
    );
}
export default App;
ReactDom.render(<App />, document.getElementById('sample'));
<!DOCTYPE html>
<html lang="en">

<head>
    <title>Syncfusion React Button</title>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <meta name="description" content="Essential JS 2 for React Components" />
    <meta name="author" content="Syncfusion" />
    <link href="index.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/33.1.44/ej2-base/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/33.1.44/ej2-react-buttons/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css" rel="stylesheet" />
    <script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.19.38/system.js"></script>
    <script src="systemjs.config.js"></script>
</head>

<body>
        <div id='sample'>
            <div id='loader'>Loading....</div>
        </div>
</body>

</html>

Clone draggable element

Create a visual copy of the dragged element during the drag operation by setting the clone property to true. When enabled, this renders a duplicate element that follows the cursor while the original element remains in its initial position. This is particularly useful for scenarios where the source item should persist, such as palette-based interfaces or template selection workflows.

import * as React from 'react';
import { useEffect } from 'react';
import * as ReactDom from 'react-dom';
import { Draggable } from '@syncfusion/ej2-base';
function App() {
    useEffect(() => {
        let draggable = new Draggable(document.getElementById('element'), { clone: true });
    }, []);
    return (<div id='container'>
      <div id='element'><p>Draggable Element</p></div>
    </div>);
}
export default App;
ReactDom.render(<App />, document.getElementById('sample'));
import * as  React from 'react';
import { useEffect } from 'react';
import * as ReactDom from 'react-dom';
import { Draggable } from '@syncfusion/ej2-base';

function App() {

  useEffect(() => {
    let draggable: Draggable = new Draggable(document.getElementById('element'),{ clone: true });
  },[])

  return (
    <div id='container'>
      <div id='element'><p>Draggable Element</p></div>
    </div>
  );
}
export default App;
ReactDom.render(<App />, document.getElementById('sample'));
<!DOCTYPE html>
<html lang="en">

<head>
    <title>Syncfusion React Button</title>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <meta name="description" content="Essential JS 2 for React Components" />
    <meta name="author" content="Syncfusion" />
    <link href="index.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/33.1.44/ej2-base/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/33.1.44/ej2-react-buttons/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css" rel="stylesheet" />
    <script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.19.38/system.js"></script>
    <script src="systemjs.config.js"></script>
</head>

<body>
        <div id='sample'>
            <div id='loader'>Loading....</div>
        </div>
</body>

</html>

Drag area

A drag area is a specific area within a user interface that is designated for drag and drop operations. When an object or element is dragged within a drag area, certain actions or events may be triggered.
Define a constrained drag region by setting the dragArea property to a valid CSS selector or DOM element reference. This restricts the draggable element’s movement to within the specified container boundaries, preventing it from being dragged outside the designated area. This is essential for maintaining layout integrity and creating bounded interaction zones. The example below demonstrates drag area constraint implementation.

import * as React from 'react';
import * as ReactDom from 'react-dom';
import { useEffect } from 'react';
import { Draggable } from '@syncfusion/ej2-base';
function App() {
    useEffect(() => {
        let draggable = new Draggable(document.getElementById('draggable'), { clone: false, dragArea: "#droppable" });
    }, []);
    return (<div id='container'>
           <div id='droppable'><p>Drag Area </p></div>
           <div id='draggable'><p id='drag'>Draggable Element </p></div>
        </div>);
}
export default App;
ReactDom.render(<App />, document.getElementById('sample'));
import * as React from 'react';
import * as ReactDom from 'react-dom';
import { useEffect } from 'react';
import { Draggable } from '@syncfusion/ej2-base';

function App() {
    useEffect(() => {
        let draggable: Draggable = new Draggable(document.getElementById('draggable'),{ clone: false, dragArea: "#droppable" });
    },[])

    return (
        <div id='container'>
           <div id='droppable'><p>Drag Area </p></div>
           <div id='draggable'><p id='drag'>Draggable Element </p></div>
        </div>
    );
}
export default App;
ReactDom.render(<App />, document.getElementById('sample'));
<!DOCTYPE html>
<html lang="en">

<head>
    <title>Syncfusion React Button</title>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <meta name="description" content="Essential JS 2 for React Components" />
    <meta name="author" content="Syncfusion" />
    <link href="index.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/33.1.44/ej2-base/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/33.1.44/ej2-react-buttons/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css" rel="stylesheet" />
    <script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.19.38/system.js"></script>
    <script src="systemjs.config.js"></script>
</head>

<body>
        <div id='sample'>
            <div id='loader'>Loading....</div>
        </div>
</body>

</html>

Droppable

A droppable zone is an area that accepts and responds to draggable elements when they are released over it. The Droppable utility converts any DOM element into a valid drop target, enabling interaction with draggable items.

When a draggable element is released over a droppable zone, the drop event is triggered. This event provides detailed information through its arguments, including references to the dragged element (droppedElement), the drop target (target), and the original drag source. This data enables implementation of actions such as appending elements, updating data models, applying visual feedback, or triggering state changes based on the drop interaction.

Refer to the following example to implement droppable zones with drag-and-drop interaction handling.

import * as React from 'react';
import * as ReactDom from 'react-dom';
import { useEffect } from 'react';
import { Draggable, Droppable } from '@syncfusion/ej2-base';
function App() {
    useEffect(() => {
        let draggable = new Draggable(document.getElementById('draggable'), { clone: false });
        let droppable = new Droppable(document.getElementById('droppable'), {
            drop: (e) => {
                e.droppedElement.querySelector('#drag').textContent = 'Dropped';
            }
        });
    }, []);
    return (<div id='container'>
           <div id='droppable'><p>Droppable Target </p></div>
           <div id='draggable'><p id='drag'>Draggable Element </p></div>
        </div>);
}
export default App;
ReactDom.render(<App />, document.getElementById('sample'));
import * as React from 'react';
import * as ReactDom from 'react-dom';
import { useEffect } from 'react';
import { Draggable, Droppable, DropEventArgs } from '@syncfusion/ej2-base';

function App() {
    useEffect(() => {
        let draggable: Draggable = new Draggable(document.getElementById('draggable'),{ clone: false });
        let droppable: Droppable = new Droppable(document.getElementById('droppable'), {
            drop: (e: DropEventArgs) => {
                e.droppedElement.querySelector('#drag').textContent = 'Dropped';
            }
        });
    },[])

    return (
        <div id='container'>
           <div id='droppable'><p>Droppable Target </p></div>
           <div id='draggable'><p id='drag'>Draggable Element </p></div>
        </div>
    );
}
export default App;
ReactDom.render(<App />, document.getElementById('sample'));
<!DOCTYPE html>
<html lang="en">

<head>
    <title>Syncfusion React Button</title>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <meta name="description" content="Essential JS 2 for React Components" />
    <meta name="author" content="Syncfusion" />
    <link href="index.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/33.1.44/ej2-base/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/33.1.44/ej2-react-buttons/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css" rel="stylesheet" />
    <script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.19.38/system.js"></script>
    <script src="systemjs.config.js"></script>
</head>

<body>
        <div id='sample'>
            <div id='loader'>Loading....</div>
        </div>
</body>

</html>

Syncfusion AI Assistant

How can I help you?

Drag and Drop for Angular Components

2 Feb 20267 minutes to read

Drag and drop is a direct manipulation interface pattern that allows users to select objects, move them to different locations, and release them to perform actions such as reordering, moving between containers, or organizing content. This intuitive interaction improves usability in applications like task managers, file explorers, and kanban boards.

Syncfusion® Angular components provide robust drag and drop support through the Draggable and Droppable classes from the @syncfusion/ej2-base package. These classes can be applied to any DOM element, enabling flexible and customizable drag-and-drop experiences.

Import the required classes in your component:

import { Draggable, Droppable } from '@syncfusion/ej2-base';

Making Elements Draggable

To enable dragging on any HTML element, create a Draggable instance and pass the target element.

The following example demonstrates basic draggable functionality:

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'



import { Component, ViewChild } from '@angular/core';
import { Draggable } from  '@syncfusion/ej2-base';

@Component({

standalone: true,
    selector: 'app-root',
    template:` <div id='container'>
    <div #ele class='element'><p class='drag'>Draggable Element </p></div>
    </div> `,
    styleUrls: ['../index.css']
})

export class AppComponent {

@ViewChild('ele',{static: false})element:any;

    ngAfterViewInit() {
        let draggable: Draggable =
        new Draggable(this.element.nativeElement,{ clone: false });
    }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Creating a Clone During Drag

Set the clone property to true to display a visual copy of the dragged element while the original remains in place. This is useful for drag-and-drop operations where the source should not move until dropped successfully.

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'

import { Component, ViewChild } from '@angular/core';
import { Draggable } from  '@syncfusion/ej2-base';

@Component({
standalone: true,
    selector: 'app-root',
    template:` <div id='container'>
    <div #ele class='element'><p class='drag'>Draggable Element </p></div>
    </div> `,
    styleUrls: ['../index.css']
})

export class AppComponent {

@ViewChild('ele',{static: false})element:any;

    ngAfterViewInit() {
        let draggable: Draggable =
        new Draggable(this.element.nativeElement,{ clone: true });
    }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Restricting the Drag Area

Limit the draggable movement to a specific container by setting the dragArea property to a CSS selector or DOM element. The dragged element (or its clone) will be constrained within these boundaries.

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'

 import { Component, ViewChild } from '@angular/core';
 import { Draggable, Droppable, DropEventArgs } from '@syncfusion/ej2-base';

 @Component({
standalone: true,
    selector: 'app-root',
    template:` <div id='container'>
    <div id='droppable'><p class='drop'>Drop target </p></div>
    <div id='draggable'><p class='drag'>Draggable Element </p></div>
    </div> `,
    styleUrls: ['../index.css']
})

export class AppComponent {
    @ViewChild('droppable',{static: false})element: any;
    @ViewChild('draggable',{static: false})element1: any;

    ngAfterViewInit() {
        let draggable: Draggable = new Draggable(document.getElementById('draggable') as HTMLElement, { clone: false, dragArea: "#droppable" });
    }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Creating Drop Targets

The Droppable class designates elements as valid drop zones. When a draggable element is released over a droppable target, the drop event fires, providing details such as the target, dragged element, and helper (clone).

Use this event to append or move the dragged element to the drop target.

The following example shows basic drag-and-drop between containers:

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'


 
 import { Component, ViewChild } from '@angular/core';
 import { Draggable, Droppable, DropEventArgs } from '@syncfusion/ej2-base';

 @Component({

standalone: true,
    selector: 'app-root',
    template:` <div id='container'>
    <div id='droppable'><p class='drop'>Drop target </p></div>
    <div id='draggable'><p class='drag'>Draggable Element </p></div>
    </div> `,
    styleUrls: ['../index.css']
})

export class AppComponent {
    @ViewChild('droppable',{static: false})element: any;
    @ViewChild('draggable',{static: false})element1: any;

    ngAfterViewInit() {
        let draggable: Draggable = new Draggable(document.getElementById('draggable') as HTMLElement , {clone: false});
        let droppable: Droppable = new Droppable(document.getElementById('droppable') as HTMLElement , {
            drop: (e: DropEventArgs) => {
                ((e.droppedElement as HTMLElement).querySelector('.drag') as Element).textContent = 'Dropped';
            }
        });
    }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));